//+------------------------------------------------------------------+
//|                                                     TestEdit.mq4 |
//|                                            Forex-softprogramming |
//|                                http://forex-softprogramming.com/ |
//+------------------------------------------------------------------+
#property copyright "Forex-softprogramming"
#property link      "http://forex-softprogramming.com/"
#property version   "1.00"


extern bool   Use_All_Symbols=true;

extern ENUM_TIMEFRAMES TF1=PERIOD_H4;
extern ENUM_TIMEFRAMES TF2=PERIOD_D1;
extern ENUM_TIMEFRAMES TF3=PERIOD_W1;
extern ENUM_TIMEFRAMES TF4=PERIOD_H1;
extern ENUM_TIMEFRAMES TF5=PERIOD_M15;
extern ENUM_TIMEFRAMES TF6=PERIOD_M5;

bool START;
string symbols[];
int OnInit()
  {  
    START=true;
    if(Use_All_Symbols) SetSymbols();
    else
    {
      ArrayResize(symbols,1);
      symbols[0]=_Symbol;
    }
   return(INIT_SUCCEEDED);
  }
void OnDeinit(const int reason)
  {
//---
   
  }
void OnTick()
  {
    if(START)
    {
      if(!CheckData()) return;
      START=false;
    }
   
  }  
void SetSymbols()
{
  int n=SymbolsTotal(true);
  ArrayResize(symbols,n);
  for(int i=0; i<n; i++)
  {
    symbols[i]=SymbolName(i,true);
  }
}
bool CheckData()
{
  int n=ArraySize(symbols);
  for(int i=0; i<n; i++)
  {
  string symbol=symbols[i];
  if(!DatareadyForSymbol(symbol,TF1)) return false;
  if(!DatareadyForSymbol(symbol,TF2)) return false;
  if(!DatareadyForSymbol(symbol,TF3)) return false;
  if(!DatareadyForSymbol(symbol,TF4)) return false;
  if(!DatareadyForSymbol(symbol,TF5)) return false;
  if(!DatareadyForSymbol(symbol,TF6)) return false;
  }
  return true;
}
bool DatareadyForSymbol(string symbol, ENUM_TIMEFRAMES tf)
{
  iTime(symbol, tf, 1);
  int err=GetLastError();
  if(err == ERR_NO_ERROR) return true;
  else
  {
    Print("error ",err," symbol  "+symbol+" TF  "+Frame(tf));
    return false;
  }
} 
string Frame(int a)
{
    string per;
            switch(a)
            {
              case 1 : per="M1";break;
              case 5 : per="M5";break;
              case 15: per="M15";break;
              case 30: per="M30";break;
              case 60: per="H1";break;
              case 240:per="H4";break;
              case 1440:per="D1";break;
              case 10080:per="W1";break;
              case 43200:per="MN";break;
            }
        return(per);
}  